export declare type AutomataSpec<X extends string | number, S = any, T extends string = string, P = any, A = StandardAction<T, P>> = {
    [state in X]: ReducerSpec<X, S, T, P, A>;
};
export interface ReducerSpec<X extends string | number, S = any, T extends string = string, P = any, A = StandardAction<T, P>> {
    [type: string]: (Reducer<S, T, P, A> | X)[] | Reducer<S, T, P, A> | X;
}
export declare type Reducer<S, T extends string = string, P = any, A = StandardAction<T, P>> = (state?: S, action?: A) => S;
export interface StandardAction<T extends string = string, P = any> {
    type: T;
    payload?: P;
}
export interface AutomataReducerOptions<X extends string | number = string, K extends string | number = 'state', I extends {
    [key in K]: X;
} = {
    [key in K]: X;
}, O = I, T extends string = string, P = any> {
    key: K;
    toStandardAction: ActionStandardizer<T, P>;
    operator: Operator<I, O>;
}
export declare type ActionStandardizer<T extends string = string, P = any> = <A>(action: A) => StandardAction<T, P>;
export declare type Operator<I = {}, O = I> = (fn: (i: I, ...args: any[]) => I) => (o: O, ...args: any[]) => O;
export default function createAutomataReducer<X extends string | number, K extends string | number = 'state', I extends {
    [key in K]: X;
} = {
    [key in K]: X;
}, O = I, T extends string = string, P = any, A = StandardAction<T, P>>(automata: AutomataSpec<X, I, T, P, A>, init: X, opts?: Partial<AutomataReducerOptions<X, K, I, O, T, P>> | string): Reducer<O, T, P, A>;
